"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var useVirtualField_1 = require("../hooks/useVirtualField");
var shared_1 = require("@formily/shared");
var context_1 = require("../context");
exports.VirtualField = function (props) {
    var _a = useVirtualField_1.useVirtualField(props), state = _a.state, field = _a.field, innerProps = _a.props, form = _a.form;
    if (!state.visible || !state.display)
        return react_1.default.createElement(react_1.default.Fragment, null);
    if (shared_1.isFn(props.children)) {
        return (react_1.default.createElement(context_1.FieldContext.Provider, { value: field }, props.children({
            form: form,
            state: state,
            props: innerProps
        })));
    }
    else {
        return (react_1.default.createElement(context_1.FieldContext.Provider, { value: field }, props.children));
    }
};
exports.VirtualField.displayName = 'ReactInternalVirtualField';
exports.VirtualField.defaultProps = {
    path: ''
};
