/// <reference types="react" />
import { Broadcast } from './shared';
import { ILayoutProps } from './types';
export declare const BroadcastContext: import("react").Context<Broadcast>;
export declare const FieldContext: import("react").Context<{
    factory: import("@formily/core").IModelSpec<Partial<import("@formily/core").IFieldState<any>>, import("@formily/core").IFieldStateProps>;
    state: import("@formily/core").IFieldState<any>;
    prevState: import("@formily/core").IFieldState<any>;
    props: import("@formily/core").IFieldStateProps;
    patches: {
        op: "replace" | "add" | "remove";
        path: (string | number)[];
        value?: any;
    }[];
    dirtyStack: import("@formily/core").StateDirtyMap<import("@formily/core").IFieldState<any>>[];
    dirtyCountStack: number[];
    batching: boolean;
    cache: Map<any, any>;
    displayName: string;
    enterCalculateDirtys(): void;
    existCalculateDirtys(): void;
    dirtys: import("@formily/core").StateDirtyMap<import("@formily/core").IFieldState<any>>;
    dirtyCount: number;
    getBaseState(): any;
    getDirtysFromPatches(patches: {
        op: "replace" | "add" | "remove";
        path: (string | number)[];
        value?: any;
    }[], refresh?: boolean): import("@formily/core").StateDirtyMap<import("@formily/core").IFieldState<any>>;
    dirtyCheck(path: import("@formily/core").FormPathPattern, nextValue: any): boolean;
    setState(recipe?: (state?: import("@formily/core").IFieldState<any>) => any, silent?: boolean): void;
    setSourceState(recipe?: (state?: import("@formily/core").IFieldState<any>) => any): import("@formily/core").IFieldState<any>;
    getState<T extends (state?: import("@formily/core").IFieldState<any>) => any>(recipe?: T): T extends (state?: import("@formily/core").IFieldState<any>) => any ? ReturnType<T> : import("@formily/core").IFieldState<any>;
    getSourceState<T_1 extends (state?: import("@formily/core").IFieldState<any>) => any>(recipe?: T_1): T_1 extends (state?: import("@formily/core").IFieldState<any>) => any ? ReturnType<T_1> : import("@formily/core").IFieldState<any>;
    batch(callback?: () => void): void;
    setCache(key: string | number | Symbol, value: any): void;
    getCache(key: string | number | Symbol): any;
    removeCache(key: string | number | Symbol): void;
    isDirty(key?: string): boolean;
    hasChanged: (pattern?: import("@formily/core").FormPathPattern) => boolean;
    subscribers: {
        [key: number]: import("@formily/shared").Subscriber<any>;
        index?: number;
    };
    subscription: import("@formily/shared").Subscription<any>;
    subscribe: (callback?: import("@formily/shared").Subscriber<any>) => number;
    unsubscribe: (index: number) => void;
    notify: (payload?: any, silent?: boolean) => void;
} | {
    factory: import("@formily/core").IModelSpec<Partial<import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>>, import("@formily/core").IVirtualFieldStateProps>;
    state: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
    prevState: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
    props: import("@formily/core").IVirtualFieldStateProps;
    patches: {
        op: "replace" | "add" | "remove";
        path: (string | number)[];
        value?: any;
    }[];
    dirtyStack: import("@formily/core").StateDirtyMap<import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>>[];
    dirtyCountStack: number[];
    batching: boolean;
    cache: Map<any, any>;
    displayName: string;
    enterCalculateDirtys(): void;
    existCalculateDirtys(): void;
    dirtys: import("@formily/core").StateDirtyMap<import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>>;
    dirtyCount: number;
    getBaseState(): any;
    getDirtysFromPatches(patches: {
        op: "replace" | "add" | "remove";
        path: (string | number)[];
        value?: any;
    }[], refresh?: boolean): import("@formily/core").StateDirtyMap<import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>>;
    dirtyCheck(path: import("@formily/core").FormPathPattern, nextValue: any): boolean;
    setState(recipe?: (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any, silent?: boolean): void;
    setSourceState(recipe?: (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any): import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
    getState<T_2 extends (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any>(recipe?: T_2): T_2 extends (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any ? ReturnType<T_2> : import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
    getSourceState<T_1_1 extends (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any>(recipe?: T_1_1): T_1_1 extends (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any ? ReturnType<T_1_1> : import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
    batch(callback?: () => void): void;
    setCache(key: string | number | Symbol, value: any): void;
    getCache(key: string | number | Symbol): any;
    removeCache(key: string | number | Symbol): void;
    isDirty(key?: string): boolean;
    hasChanged: (pattern?: import("@formily/core").FormPathPattern) => boolean;
    subscribers: {
        [key: number]: import("@formily/shared").Subscriber<any>;
        index?: number;
    };
    subscription: import("@formily/shared").Subscription<any>;
    subscribe: (callback?: import("@formily/shared").Subscriber<any>) => number;
    unsubscribe: (index: number) => void;
    notify: (payload?: any, silent?: boolean) => void;
}>;
export declare const LayoutContext: import("react").Context<Pick<ILayoutProps, "required" | "label" | "span" | "inset" | "size" | "inline" | "flex" | "grid" | "context" | "hasBorder" | "isRoot" | "isLayout" | "defaultSettings" | "full" | "labelAlign" | "autoRow" | "columns" | "enableSafeWidth" | "labelWidth" | "wrapperWidth" | "labelCol" | "wrapperCol" | "addonBefore" | "addonAfter" | "description" | "gutter" | "contextColumns" | "contextResponsive" | "responsive">>;
declare const _default: import("react").Context<{
    submit: (onSubmit?: (values: any) => any) => Promise<import("@formily/core").IFormSubmitResult>;
    reset: (props?: import("@formily/core").IFormResetOptions) => Promise<void | import("@formily/core").ValidateNodeResult>;
    hasChanged: (target: any, path: import("@formily/core").FormPathPattern) => boolean;
    clearErrors: (pattern?: import("@formily/core").FormPathPattern) => void;
    validate: (path?: import("@formily/core").FormPathPattern, opts?: import("@formily/core").IFormExtendedValidateFieldOptions) => Promise<import("@formily/core").ValidateNodeResult>;
    setFormState: (callback?: (state: import("@formily/core").IFormState<any>) => any, silent?: boolean) => void;
    getFormState: (callback?: (state: import("@formily/core").IFormState<any>) => any) => any;
    setFieldState: (path: import("@formily/core").FormPathPattern, callback?: (state: import("@formily/core").IFieldState<FormilyCore.FieldProps>) => void, silent?: boolean) => void;
    getFieldState: (path: import("@formily/core").FormPathPattern, callback?: (state: import("@formily/core").IFieldState<FormilyCore.FieldProps>) => any) => any;
    registerField: ({ path, name, value, initialValue, required, rules, editable, visible, display, computeState, dataType, props }: import("@formily/core").IFieldRegistryProps<FormilyCore.FieldProps>) => {
        factory: import("@formily/core").IModelSpec<Partial<import("@formily/core").IFieldState<any>>, import("@formily/core").IFieldStateProps>;
        state: import("@formily/core").IFieldState<any>;
        prevState: import("@formily/core").IFieldState<any>;
        props: import("@formily/core").IFieldStateProps;
        patches: {
            op: "replace" | "add" | "remove";
            path: (string | number)[];
            value?: any;
        }[];
        dirtyStack: import("@formily/core").StateDirtyMap<import("@formily/core").IFieldState<any>>[];
        dirtyCountStack: number[];
        batching: boolean;
        cache: Map<any, any>;
        displayName: string;
        enterCalculateDirtys(): void;
        existCalculateDirtys(): void;
        dirtys: import("@formily/core").StateDirtyMap<import("@formily/core").IFieldState<any>>;
        dirtyCount: number;
        getBaseState(): any;
        getDirtysFromPatches(patches: {
            op: "replace" | "add" | "remove";
            path: (string | number)[];
            value?: any;
        }[], refresh?: boolean): import("@formily/core").StateDirtyMap<import("@formily/core").IFieldState<any>>;
        dirtyCheck(path: import("@formily/core").FormPathPattern, nextValue: any): boolean;
        setState(recipe?: (state?: import("@formily/core").IFieldState<any>) => any, silent?: boolean): void;
        setSourceState(recipe?: (state?: import("@formily/core").IFieldState<any>) => any): import("@formily/core").IFieldState<any>;
        getState<T extends (state?: import("@formily/core").IFieldState<any>) => any>(recipe?: T): T extends (state?: import("@formily/core").IFieldState<any>) => any ? ReturnType<T> : import("@formily/core").IFieldState<any>;
        getSourceState<T_1 extends (state?: import("@formily/core").IFieldState<any>) => any>(recipe?: T_1): T_1 extends (state?: import("@formily/core").IFieldState<any>) => any ? ReturnType<T_1> : import("@formily/core").IFieldState<any>;
        batch(callback?: () => void): void;
        setCache(key: string | number | Symbol, value: any): void;
        getCache(key: string | number | Symbol): any;
        removeCache(key: string | number | Symbol): void;
        isDirty(key?: string): boolean;
        hasChanged: (pattern?: import("@formily/core").FormPathPattern) => boolean;
        subscribers: {
            [key: number]: import("@formily/shared").Subscriber<any>;
            index?: number;
        };
        subscription: import("@formily/shared").Subscription<any>;
        subscribe: (callback?: import("@formily/shared").Subscriber<any>) => number;
        unsubscribe: (index: number) => void;
        notify: (payload?: any, silent?: boolean) => void;
    };
    registerVirtualField: ({ name, path, display, visible, computeState, props }: import("@formily/core").IVirtualFieldRegistryProps<FormilyCore.VirtualFieldProps>) => {
        factory: import("@formily/core").IModelSpec<Partial<import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>>, import("@formily/core").IVirtualFieldStateProps>;
        state: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
        prevState: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
        props: import("@formily/core").IVirtualFieldStateProps;
        patches: {
            op: "replace" | "add" | "remove";
            path: (string | number)[];
            value?: any;
        }[];
        dirtyStack: import("@formily/core").StateDirtyMap<import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>>[];
        dirtyCountStack: number[];
        batching: boolean;
        cache: Map<any, any>;
        displayName: string;
        enterCalculateDirtys(): void;
        existCalculateDirtys(): void;
        dirtys: import("@formily/core").StateDirtyMap<import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>>;
        dirtyCount: number;
        getBaseState(): any;
        getDirtysFromPatches(patches: {
            op: "replace" | "add" | "remove";
            path: (string | number)[];
            value?: any;
        }[], refresh?: boolean): import("@formily/core").StateDirtyMap<import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>>;
        dirtyCheck(path: import("@formily/core").FormPathPattern, nextValue: any): boolean;
        setState(recipe?: (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any, silent?: boolean): void;
        setSourceState(recipe?: (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any): import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
        getState<T_2 extends (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any>(recipe?: T_2): T_2 extends (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any ? ReturnType<T_2> : import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
        getSourceState<T_3 extends (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any>(recipe?: T_3): T_3 extends (state?: import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any ? ReturnType<T_3> : import("@formily/core").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
        batch(callback?: () => void): void;
        setCache(key: string | number | Symbol, value: any): void;
        getCache(key: string | number | Symbol): any;
        removeCache(key: string | number | Symbol): void;
        isDirty(key?: string): boolean;
        hasChanged: (pattern?: import("@formily/core").FormPathPattern) => boolean;
        subscribers: {
            [key: number]: import("@formily/shared").Subscriber<any>;
            index?: number;
        };
        subscription: import("@formily/shared").Subscription<any>;
        subscribe: (callback?: import("@formily/shared").Subscriber<any>) => number;
        unsubscribe: (index: number) => void;
        notify: (payload?: any, silent?: boolean) => void;
    };
    createMutators: (input: any) => {
        change(...values: any[]): any;
        focus(): void;
        blur(): void;
        push(value?: any): any[];
        pop(): any[];
        insert(index: number, value: any): any;
        remove(index?: string | number): void;
        exist(index?: string | number): boolean;
        unshift(value: any): any;
        shift(): void;
        move($from: number, $to: number): any[];
        moveUp(index: number): any[];
        moveDown(index: number): any[];
        validate(opts?: import("@formily/core").IFormExtendedValidateFieldOptions): Promise<import("@formily/core").ValidateNodeResult>;
    };
    getFormGraph: () => any;
    setFormGraph: (nodes: {
        [key: string]: any;
    }) => void;
    setFieldValue: (path: import("@formily/core").FormPathPattern, value?: any, silent?: boolean) => void;
    getFieldValue: (path?: import("@formily/core").FormPathPattern) => any;
    setFieldInitialValue: (path?: import("@formily/core").FormPathPattern, value?: any, silent?: boolean) => void;
    getFieldInitialValue: (path?: import("@formily/core").FormPathPattern) => any;
    disableUnmountClearStates: (pattern?: import("@formily/core").FormPathPattern) => void;
    enableUnmountClearStates: (pattern?: import("@formily/core").FormPathPattern) => void;
    isHostRendering: () => boolean;
    hostUpdate: (callback?: () => any) => any;
    subscribe: (callback?: import("@formily/core").FormHeartSubscriber) => number;
    unsubscribe: (id: number) => void;
    notify: (type: string, payload: any) => void;
}>;
export default _default;
